/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { typeCast, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinancialOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialOverlay, _super);
    function FinancialOverlay() {
        var _this = _super.call(this) || this;
        _this.aba = false;
        _this.aba = false;
        return _this;
    }
    FinancialOverlay.prototype.get_fa = function () {
        return true;
    };
    FinancialOverlay.prototype.ph = function (a, b, c, d) {
        _super.prototype.ph.call(this, a, b, c, d);
        if (this.xg != null && typeCast(ISortingAxis_$type, this.xg) !== null) {
            this.xg.i$i();
        }
        this.xx.cd.e(this.ie);
        this.abb();
        if (this.xz != null) {
            this.xz.d2();
        }
        this.ry(true);
    };
    FinancialOverlay.prototype.get_he = function () {
        return true;
    };
    FinancialOverlay.prototype.rg = function (a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.aba = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.aba = false;
                this.ry(false);
                this.qr();
                break;
            case "XAxis":
                this.aba = false;
                break;
        }
        _super.prototype.rg.call(this, a, b, c, d);
    };
    FinancialOverlay.prototype.b3 = function () {
        if (this.b4 == 0) {
            return 1;
        }
        else {
            return _super.prototype.b3.call(this);
        }
    };
    FinancialOverlay.prototype.gx = function (a, b) {
        if (this.gw(a, b)) {
            return true;
        }
        return false;
    };
    FinancialOverlay.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.ry(false);
    };
    FinancialOverlay.prototype.ge = function (a) {
        var b = this.dp != null ? this.dp.indexOf(a) : -1;
        var c = this.cw.ca;
        c = c.copy();
        var d = this.cw.b9;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.wv(this.cw);
        var g = new ScalerParams(0, e, e, this.xg.df, f);
        var h = new ScalerParams(0, e, e, this.xz.df, f);
        h.b = this.i0();
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.xg != null) {
                var i = this.xg.ft(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.xz != null && this.yb != null && this.ya != null && b < this.yb.count && b < this.ya.count) {
                var j = this.xz.ft(this.yb.item(b), h);
                var k = this.xz.ft(this.ya.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.c4.au(this.dc, c, true);
        }
        return b >= 0;
    };
    FinancialOverlay.prototype.ay = function (a) {
        if (a != null && a == this.xz && this.yb != null && this.ya != null) {
            return new AxisRange(this.yb.minimum, this.ya.maximum);
        }
        return null;
    };
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:abc:abe', [1, 0]]);
    return FinancialOverlay;
}(FinancialSeries));
export { FinancialOverlay };
